#!/usr/bin/perl

##############################################################################
#                      << phpBB2 Posts and Topics >>                         #
##############################################################################
#  Script:       phpBB2 Posts and Topics                                     #
#  Version:      1.0.0 (16.02.2005)                                          #
#  Filename:     phpbb2stats.pl                                              #
#  Description:  Fetches posts and topics posted on a phpBB2 forum           #
#                - number of posts and topics posted during the last hour    #
#                - number of posts and topics posted during the last 3 hours #
#  Written by:   Sam Salonen sam@aqua-web.org                                #
#                                                                            #
##############################################################################

use DBI;

# Define the databaseconnection
my $dsn          = 'DBI:mysql:database_name:host_name';
my $db_user_name = 'database_username';
my $db_password  = 'database_password';
my $dbh          = DBI->connect($dsn, $db_user_name, $db_password);

my $sth;

# Fetch number of posts posted during the last hour
$sth = $dbh->prepare("SELECT COUNT(post_id) AS posts FROM phpbb_posts WHERE (post_time + 3600) > UNIX_TIMESTAMP(NOW())");
$sth->execute();
my $posts1h = $sth->fetchrow_array();
$sth->finish();
# print out the result ($posts1h)
print "posts1h:$posts1h ";

# Fetch number of posts posted during the last 3 hours
$sth = $dbh->prepare("SELECT COUNT(post_id) AS posts FROM phpbb_posts WHERE (post_time + 10800) > UNIX_TIMESTAMP(NOW())");
$sth->execute();
my $posts3h = $sth->fetchrow_array();
$sth->finish();
# print out the result ($posts3h)
print "posts3h:$posts3h ";

# Fetch number of topics posted during the last hour
$sth = $dbh->prepare("SELECT COUNT(topic_id) AS posts FROM phpbb_topics WHERE (topic_time + 3600) > UNIX_TIMESTAMP(NOW())");
$sth->execute();
my $topics1h = $sth->fetchrow_array();
$sth->finish();
# print out the result ($topics1h)
print "topics1h:$topics1h ";


# Fetch number of topics posted during the last 3 hour
$sth = $dbh->prepare("SELECT COUNT(topic_id) AS posts FROM phpbb_topics WHERE (topic_time + 10800) > UNIX_TIMESTAMP(NOW())");
$sth->execute();
my $topics3h = $sth->fetchrow_array();
$sth->finish();
# print out the result ($topics3h)
print "topics3h:$topics3h ";

